#! /bin/bash
############################################################################
##                                                                        ##
##     Copyright (C) 2010-2011  YannUbuntu (yannubuntu@gmail.com)         ##
##                                                                        ##
## This program is free software: you can redistribute it and/or modify   ##
## it under the terms of the GNU General Public License as published by   ##
## the Free Software Foundation, either version 3 of the License, or      ##
## (at your option) any later version.                                    ##
##                                                                        ##
## This program is distributed in the hope that it will be useful,        ##
## but WITHOUT ANY WARRANTY; without even the implied warranty of         ##
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          ##
## GNU General Public License for more details.                           ##
##                                                                        ##
## You should have received a copy of the GNU General Public License      ##
## along with this program.  If not, see <http://www.gnu.org/licenses/>.  ##
##                                                                        ##
############################################################################
## Special thanks to Babdu89 and GRUB devs.
## LIBRAIRIES FOR OS-UNINSTALLER AND BOOT REPAIR
## http://ubuntuforums.org/showthread.php?t=1615667

show_tab_mbr_options() {
if [[ "$1" = "on" ]];then
	echo 'SET@_tab_mbr_options.set_sensitive(True)'; echo 'SET@_vbox_mbr_options.show()'
else
	echo 'SET@_tab_mbr_options.set_sensitive(False)'; echo 'SET@_vbox_mbr_options.hide()'
fi
}

###################################### Check MBR to restore ###########################
check_which_mbr_can_be_restored() {
check_available_target_partition_for_generic_mbr
NB_MBR_CAN_BE_RESTORED=0
for ((i=1;i<=NBOFDISKS;i++)); do
	[[ "${LISTOFDISKS[$i]}" = "$CHOSEN_DISK" ]] && loop_check_which_mbr_can_be_restored
done
for ((i=1;i<=NBOFDISKS;i++)); do
	[[ "${LISTOFDISKS[$i]}" != "$CHOSEN_DISK" ]] && loop_check_which_mbr_can_be_restored
done
for ((i=1;i<=NB_MBR_CAN_BE_RESTORED;i++)); do echo "[debug]MBR that can be restored number $i : ${MBR_CAN_BE_RESTORED[$i]}"; done
}

loop_check_which_mbr_can_be_restored() {
if [[ "${TARGET_PARTITION_IS_AVAILABLE[$i]}" = "yes" ]];then
	for j in $(dir /usr/lib/syslinux | grep "mbr" ); do
		if [[ "$(echo $j | grep mbr | grep ".bin" | grep -v "[a-z]mbr" )" ]];then
			(( NB_MBR_CAN_BE_RESTORED += 1 ))
			MBR_CAN_BE_RESTORED[$NB_MBR_CAN_BE_RESTORED]="${LISTOFDISKS[$i]} (${j%.bin})"
		fi
	done
	for j in $(dir /usr/lib/syslinux | grep "mbr" ); do
		if [[ "$(echo $j | grep mbr | grep ".bin" | grep "[a-z]mbr" )" ]];then
			(( NB_MBR_CAN_BE_RESTORED += 1 ))
			MBR_CAN_BE_RESTORED[$NB_MBR_CAN_BE_RESTORED]="${LISTOFDISKS[$i]} (${j%.bin})"
		fi
	done
fi
for ((j=1;j<=QTY_OF_DISKS_WITH_BACKUP;j++)); do
	if [[ "${DISKS_WITH_BACKUP[$j]}" = "${LISTOFDISKS[$i]}" ]];then
		for k in $(dir "$LOGREP/${DISKS_WITH_BACKUP[$j]}"); do
			if [[ "$k" =~ mbr- ]];then
				(( NB_MBR_CAN_BE_RESTORED += 1 )); 
				MBR_CAN_BE_RESTORED[$NB_MBR_CAN_BE_RESTORED]="${LISTOFDISKS[$i]} \($(cut -c5-14 <<< $k ) $(cut -c17-21 <<< $k )\)"
				##Keeps the date in the name (mbr-YYYY-MM-DD__HH:MM*.img)
			fi
		done
	fi
done
if [[ "${TARGET_PARTITION_IS_AVAILABLE[$i]}" = "yes" ]];then
	(( NB_MBR_CAN_BE_RESTORED += 1 ))
	MBR_CAN_BE_RESTORED[$NB_MBR_CAN_BE_RESTORED]="${LISTOFDISKS[$i]} (xp generic)"
fi
}

###################### Combobox Restore MBR of
combobox_restore_mbrof_fillin() {
echo "[debug]combobox_restore_mbrof_fillin"
echo "SET@_label_restore_mbrof.set_text('''${Restore_the_MBR_of}''')"
while read fichier; do echo "SET@_combobox_restore_mbrof.append_text('''${fichier}''')";done < <( for ((icrmf=1;icrmf<=NB_MBR_CAN_BE_RESTORED;icrmf++)); do
	echo "${MBR_CAN_BE_RESTORED[$icrmf]}";
done)
echo 'SET@_combobox_restore_mbrof.set_active(0)'; MBR_TO_RESTORE="${MBR_CAN_BE_RESTORED[1]}"
}

_combobox_restore_mbrof() {
MBR_TO_RESTORE="${@}"; echo "[debug]MBR_TO_RESTORE becomes : $MBR_TO_RESTORE"
echo 'SET@_button_mainapply.set_sensitive(False)' #To avoid applying before variables are changed
FUNCTION="MBR"
PACKAGELIST="mbr"
FILETOTEST="install-mbr"
if [[ "$MBR_TO_RESTORE" =~ generic ]];then
	if [[ ! "$(type -p $FILETOTEST)" ]];then
		echo 'SET@_mainwindow.hide()'
		installpackagelist
		end_of_pulsate
		echo 'SET@_mainwindow.show()'
	fi
	if [[ "$(type -p $FILETOTEST)" ]] || [[ "$MBR_TO_RESTORE" = "${MBR_CAN_BE_RESTORED[1]}" ]];then		
		fill_combobox_partition_booted_bymbr
	else
		MBR_TO_RESTORE="${MBR_CAN_BE_RESTORED[1]}"; echo 'SET@_combobox_restore_mbrof.set_active(0)'
	fi
elif [[ "$MBR_TO_RESTORE" =~ __ ]];then
	fill_combobox_partition_booted_bymbr
else1
	FUNCTION="FLAG"
	PACKAGELIST="parted"
	FILETOTEST="parted"
	if [[ ! "$(type -p $FILETOTEST)" ]];then
		echo 'SET@_mainwindow.set_sensitive(False)'
		installpackagelist
		end_of_pulsate
		echo 'SET@_mainwindow.set_sensitive(True)' #dont show because window may not be initialized yet
	fi
	fill_combobox_partition_booted_bymbr
fi
echo 'SET@_button_mainapply.set_sensitive(True)'
}


################### Combobox partition booted by MBR
_combobox_partition_booted_bymbr() {
RETOURCOMBO_partition_booted_bymbr="${@}"
echo "[debug]RETOURCOMBO_partition_booted_bymbr : $RETOURCOMBO_partition_booted_bymbr"
for ((i=1;i<=QTY_TARGETMBRPART;i++)); do
	[[ "$RETOURCOMBO_partition_booted_bymbr" = "${TARGETMBRPARTNAME[$i]}" ]] && TARGET_PARTITION_FOR_MBR="${TARGETMBRPART[$i]}"
done
echo "[debug]TARGET_PARTITION_FOR_MBR becomes : ${LISTOFPARTITIONS[$TARGET_PARTITION_FOR_MBR]}"
}

fill_combobox_partition_booted_bymbr() {
echo "[debug]fill_combobox_partition_booted_bymbr"
echo "COMBO@@CLEAR@@_combobox_partition_booted_bymbr"
if [[ "$MBR_TO_RESTORE" =~ generic ]] || [[ "$MBR_TO_RESTORE" =~ mbr ]];then
	echo 'SET@_vbox_partition_booted_bymbr.show()'
	DISK_TO_RESTORE_MBR="$(cut -c1-3 <<< $MBR_TO_RESTORE )"
	TARGET_PARTITION_FOR_MBR="none"
	TMPDISK="$DISK_TO_RESTORE_MBR"
	order_primary_partitions_of_tmpdisk
	QTY_TARGETMBRPART="$QTY_PRIMPART"
	for ((i=1;i<=QTY_PRIMPART;i++)); do
		TARGETMBRPART[$i]="${PRIMPART[$i]}"			#e.g. ${LISTOFPARTITIONS[TARGETMBRPART[a]]}= sda3
		TARGETMBRPARTNAME[$i]="${PRIMPARTNAME[$i]}"	#e.g. sda3 (XP)
	done
	while read fichier; do
		echo "SET@_combobox_partition_booted_bymbr.append_text('''${fichier}''')"
	done < <( for ((i=1;i<=QTY_TARGETMBRPART;i++)); do
		echo "${TARGETMBRPARTNAME[$i]}"
	done)
	echo 'SET@_combobox_partition_booted_bymbr.set_active(0)'; 
	TARGET_PARTITION_FOR_MBR="${TARGETMBRPART[1]}"
	echo "[debug]TARGET_PARTITION_FOR_MBR is ${LISTOFPARTITIONS[$TARGET_PARTITION_FOR_MBR]}"
else
	echo 'SET@_vbox_partition_booted_bymbr.hide()'
fi
}

order_primary_partitions_of_tmpdisk() {
# called by fill_combobox_partition_booted_bymbr and fillin_bootflag_combobox
QTY_PRIMPART="0"
for loop2 in 1 2 3;do
	for ((i=1;i<=NBOFPARTITIONS;i++)); do
		ADDPART=no; ADDTMPNAME=""
		if [[ "${LISTOFPARTITIONS[$i]}" = "${TMPDISK}1" ]] || [[ "${LISTOFPARTITIONS[$i]}" = "${TMPDISK}2" ]] \
		|| [[ "${LISTOFPARTITIONS[$i]}" = "${TMPDISK}3" ]] || [[ "${LISTOFPARTITIONS[$i]}" = "${TMPDISK}4" ]] \
		&& [[ "${LISTOFPARTITIONS[$i]}" != "$OS_TO_DELETE_PARTITION" ]];then
			if [[ "$loop2" = "1" ]] && [[ "${PART_WITH_OS[$i]}" = "with-os" ]] && [[ "$(grep -iv Recovery <<< ${OSNAME[$i]} )" ]] \
			&& [[ "$(grep -i Windows <<< ${OSNAME[$i]} )" ]];then
				ADDPART=yes; ADDTMPNAME=" (${OSNAME[$i]})"
			elif [[ "$(grep -i Recovery <<< ${OSNAME[$i]} )" ]] || [[ "$(grep -iv Windows <<< ${OSNAME[$i]} )" ]] \
			&& [[ "${PART_WITH_OS[$i]}" = "with-os" ]] && [[ "$loop2" = "2" ]];then
				ADDPART=yes; ADDTMPNAME=" (${OSNAME[$i]})"
			elif [[ "$loop2" = "3" ]] && [[ "${PART_WITH_OS[$i]}" != "with-os" ]];then
				ADDPART=yes
			fi
			if [[ "$ADDPART" = "yes" ]];then
				(( QTY_PRIMPART += 1 ))
				PRIMPART[$QTY_PRIMPART]="$i"	#e.g. ${LISTOFPARTITIONS[FLAGPART[a]]}= sda3
				PRIMPARTNAME[$QTY_PRIMPART]="${LISTOFPARTITIONS[$i]}$ADDTMPNAME"	#e.g. sda3 (XP)
			fi
		fi
	done
done
}

check_available_target_partition_for_generic_mbr() {
for ((m=1;m<=NBOFDISKS;m++)); do
	TARGET_PARTITION_IS_AVAILABLE[$m]="no"
	for ((i=1;i<=TOTAL_QUANTITY_OF_OS;i++)); do # Display and select in priority partitions with OS detected by os-prober
		for ((k=1;k<=4;k++)); do
			if [[ "${OS_PARTITION[$i]}" = "${LISTOFDISKS[$m]}$k" ]] && [[ "${OS_PARTITION[$i]}" != "$OS_TO_DELETE_PARTITION" ]];then
				TARGET_PARTITION_IS_AVAILABLE[$m]="yes"
			fi
		done
	done
	for ((k=1;k<=4;k++)); do
		BAD_PART="no"
		for ((j=1;j<=NBOFPARTITIONS;j++)); do
			if [[ "${LISTOFDISKS[$m]}$k" = "${LISTOFPARTITIONS[$j]}" ]];then #Exclude SWAP, EXTENDED part etc...
				for ((i=1;i<=TOTAL_QUANTITY_OF_OS;i++)); do #Exlude partitions already listed
					[[ "${OS_PARTITION[$i]}" = "${LISTOFDISKS[$m]}$k" ]] && BAD_PART="yes"
				done
				if [[ "$BAD_PART" = "no" ]] && [[ "${LISTOFDISKS[$m]}$k" != "$OS_TO_DELETE_PARTITION" ]];then
					#Partitions without OS detected by os-prober
					TARGET_PARTITION_IS_AVAILABLE[$m]="yes"
				fi
			fi
		done
	done
	echo "[debug]TARGET_PARTITION_IS_AVAILABLE[${LISTOFDISKS[$m]}] is : ${TARGET_PARTITION_IS_AVAILABLE[$m]}"
done
}
